package ads1ws08.pa1.viewer;

import java.awt.Frame;
import javax.swing.JFrame;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.io.FileInputStream;

public final class ViewerApplication extends WindowAdapter
{

private JFrame mainWindow;
private TreeViewer viewer;

public
ViewerApplication( String fileName ) throws Exception
{
	TreeReader reader = null;
	
	if (fileName != null) {
		try {
			reader = new TreeReader(new FileInputStream(fileName));
		} catch (Exception e) {
		}
	}

	if (reader == null) reader = new TreeReader(System.in);

	viewer = new TreeViewer(reader, fileName);

	mainWindow = new JFrame("AVL tree viewer");

	mainWindow.addWindowListener(this);

	mainWindow.setLocation(0, 0);
	// mainWindow.setSize(mainWindow.getToolkit().getScreenSize());
	mainWindow.setSize(640, 480);
	mainWindow.setVisible(true);

	mainWindow.add(viewer);
}

public void
show()
{
	mainWindow.setVisible(true);
}

public void
windowClosing( WindowEvent e )
{
	mainWindow.dispose();
}

public static void
main( String[] args )
{
	String arg = args.length > 0 ? args[0] : null;

	try {
		ViewerApplication app = new ViewerApplication(arg);

		app.show();
	} catch (Exception e) {
		e.printStackTrace();
	}
}

} // class ViewerApplication
